

#    MIDAS Access Client  for the  ABCAccess service

package require MIDASAccessClient    ;#   load default support procedures

global ABCAccessServerHost ABCAccessServerPort

if {[info exists ABCAccessServerHost] == 0} then {set ABCAccessServerHost localhost}
if {[info exists ABCAccessServerPort] == 0} then {set ABCAccessServerPort 8015}

variable uri "urn:ABCAccessServer"
variable proxy "http://$ABCAccessServerHost:$ABCAccessServerPort/ABCAccessServer"

proc ABCAccessClient_Configure {} {
   global  ABCAccessServerHost ABCAccessServerPort
   variable proxy

   set proxy "http://$ABCAccessServerHost:$ABCAccessServerPort/ABCAccessServer"

   foreach method [info procs ABCAccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create ABCAccessClient__Init -proxy $proxy -uri $uri -timeout 1000 \
     -name Init \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name Verbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create ABCAccessClient__Get -proxy $proxy -uri $uri -timeout 1000 \
     -name Get \
     -params {Param string Index int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Set -proxy $proxy -uri $uri -timeout 1000 \
     -name Set \
     -params {Param string Index int Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Read -proxy $proxy -uri $uri -timeout 1000 \
     -name Read \
     -params {Param string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Write -proxy $proxy -uri $uri -timeout 1000 \
     -name Write \
     -params {Param string Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Apply -proxy $proxy -uri $uri -timeout 1000 \
     -name Apply \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Load -proxy $proxy -uri $uri -timeout 1000 \
     -name Load \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Status -proxy $proxy -uri $uri -timeout 1000 \
     -name Status \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create ABCAccessClient__Retrieve -proxy $proxy -uri $uri -timeout 1000 \
     -name Retrieve \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply


package provide ABCAccessClient 1.0
