

#    MIDAS Access Client  for the  XAD9252Access service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global XAD9252AccessServerHost XAD9252AccessServerPort

if {[info exists XAD9252AccessServerHost] == 0} then {set XAD9252AccessServerHost localhost}
if {[info exists XAD9252AccessServerPort] == 0} then {set XAD9252AccessServerPort 8015}


variable uri "urn:XAD9252AccessServer"
variable proxy "http://$XAD9252AccessServerHost:$XAD9252AccessServerPort/XAD9252AccessServer"

set XAD9252AccessServerTimeOut 10000

proc XAD9252AccessClient_Configure {} {
   global XAD9252AccessServerHost XAD9252AccessServerPort
   variable proxy

   set proxy "http://$XAD9252AccessServerHost:$XAD9252AccessServerPort/XAD9252AccessServer"

   foreach method [info procs XAD9252AccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create XAD9252AccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name  AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create XAD9252AccessClient__Get -proxy $proxy -uri $uri -timeout $XAD9252AccessServerTimeOut \
     -name Get \
     -params {Chip int Address int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XAD9252AccessClient__Set -proxy $proxy -uri $uri -timeout $XAD9252AccessServerTimeOut \
     -name Set \
     -params {Chip int Address int Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply


package provide XAD9252AccessClient 1.0
