# This file contains interpreter configuration material
# activated during auto-load ...

proc colour-config {option} {
   global env

  if {[file exists /usr/lib/X11/rgb.txt]} then {
   set-eg-option colour-database /usr/lib/X11/rgb.txt
  } else {
     if {[file exists /usr/openwin/lib/rgb.txt]} then {
        set-eg-option colour-database /usr/openwin/lib/rgb.txt
     } else {
        set-eg-option colour-database [file join $env(MIDASBASE) lib rgb.txt]
     }
  }

  set-eg-option colours [list \
   #000000 #000040 #000080 #0000c0 #0000ff #0040ff #0080ff #00c0ff \
   #00ffff #40ffff #80ffff #c0ffff #80ff80 #40ff40 #00ff00 #00c000 \
   #008000 #004000 #404000 #808000 #c0c000 #c0c040 #c0c080 #c0c0c0 \
   #ffffff #ffc0ff #ff80ff #ff40ff #ff00ff #400000 #c00000 #ff0000 \
  ]

  set-eg-option linecolours [list \
    black red blue green yellow magenta cyan #808080 #404040 \
    #c0c0c0 #000040 #000080 #0000c0 #800080 #008080 #808000  \
  ]

   set palette $option
   if {$option == "default"} then {set palette "Gray80"}
   if {$option == "yellow"}  then {set palette "GoldenRod2"}
   if {$option == "blue"}    then {set palette "SkyBlue"}
   set-eg-option tkpalette $palette
}

proc colour-setup {} {
  global env

  if {[winfo depth .] <= 1} then {return}
  if {[info exists env(tkwindepth)]} then {if {$env(tkwindepth) <= 1} then {return}}

#    palette color
     set colour [get-eg-option tkpalette]
     tk_setPalette $colour
#    default setup
     option add *Frame.background $colour
     option add *Listbox.background $colour
     option add *Text.background $colour
     option add *Entry.background $colour
     option add *Scale.background $colour
     option add *Label.background $colour
     option add *Message.background $colour
     option add *Button.background $colour
     option add *Checkbutton.background $colour
     option add *Checkbutton.selectColor $colour
     option add *Menubutton.background $colour
     option add *Menu.background $colour
     option add *Radiobutton.background $colour
     option add *Scrollbar.background $colour
     option add *Canvas.background $colour
     option add *Spectrum.background white
     option add *Spectrum.foreground white

  if {$env(USERCOLORS) == 0} then {return}

#   canvas widget
  if {[info exists env(tkcanvasinsertbackground)] == 1} then \
     {option add *Canvas.insertBackground  $env(tkcanvasinsertbackground)}
  if {[info exists env(tkcanvashighlightcolor)] == 1} then \
     {option add *Canvas.highlightColor $env(tkcanvashighlightcolor)}
  if {[info exists env(tkcanvashighlightbackground)] == 1} then \
     {option add *Canvas.highlightBackground $env(tkcanvashighlightbackground)}
  if {[info exists env(tkcanvasbackground)] == 1} then \
     {option add *Canvas.background  $env(tkcanvasbackground)}
  if {[info exists env(tkcanvasselectforeground)] == 1} then \
     {option add *Canvas.selectForeground  $env(tkcanvasselectforeground)}
  if {[info exists env(tkcanvasselectbackground)] == 1} then \
     {option add *Canvas.selectBackground  $env(tkcanvasselectbackground)}

#   button widget
  if {[info exists env(tkbuttonbackground)] == 1} then \
     {option add *Button.background  $env(tkbuttonbackground)}
  if {[info exists env(tkbuttonactivebackground)] == 1} then \
     {option add *Button.activeBackground  $env(tkbuttonactivebackground)}
  if {[info exists env(tkbuttonactiveforeground)] == 1} then \
     {option add *Button.activeForeground  $env(tkbuttonactiveforeground)}
  if {[info exists env(tkbuttonforeground)] == 1} then \
     {option add *Button.foreground  $env(tkbuttonforeground)}
  if {[info exists env(tkbuttondisabledforeground)] == 1} then \
     {option add *Button.disabledForeground  $env(tkbuttondisabledforeground)}
  if {[info exists env(tkbuttonhighlightbackground)] == 1} then \
     {option add *Button.highlightBackground  $env(tkbuttonhighlightbackground)}
  if {[info exists env(tkbuttonhighlightcolor)] == 1} then \
     {option add *Button.highlightColor  $env(tkbuttonhighlightcolor)}

#   checkbutton widget
  if {[info exists env(tkcheckbuttonbackground)] == 1} then \
     {option add *Checkbutton.background  $env(tkcheckbuttonbackground)}
  if {[info exists env(tkcheckbuttonactivebackground)] == 1} then \
     {option add *Checkbutton.activeBackground  $env(tkcheckbuttonactivebackground)}
  if {[info exists env(tkcheckbuttonactiveforeground)] == 1} then \
     {option add *Checkbutton.activeForeground  $env(tkcheckbuttonactiveforeground)}
  if {[info exists env(tkcheckbuttonforeground)] == 1} then \
     {option add *Checkbutton.foreground  $env(tkcheckbuttonforeground)}
  if {[info exists env(tkcheckbuttondisabledforeground)] == 1} then \
     {option add *Checkbutton.disabledForeground  $env(tkcheckbuttondisabledforeground)}
  if {[info exists env(tkcheckbuttonhighlightbackground)] == 1} then \
     {option add *Checkbutton.highlightBackground  $env(tkcheckbuttonhighlightbackground)}
  if {[info exists env(tkcheckbuttonhighlightcolor)] == 1} then \
     {option add *Checkbutton.highlightColor  $env(tkcheckbuttonhighlightcolor)}
  if {[info exists env(tkcheckbuttonselectcolor)] == 1} then \
     {option add *Checkbutton.selectColor  $env(tkcheckbuttonselectcolor)}

#   entry widget
  if {[info exists env(tkentrybackground)] == 1} then \
     {option add *Entry.background  $env(tkentrybackground)}
  if {[info exists env(tkentryforeground)] == 1} then \
     {option add *Entry.foreground  $env(tkentryforeground)}
  if {[info exists env(tkentryselectbackground)] == 1} then \
     {option add *Entry.selectBackground  $env(tkentryselectbackground)}
  if {[info exists env(tkentryselectforeground)] == 1} then \
     {option add *Entry.selectForeground  $env(tkentryselectforeground)}
  if {[info exists env(tkentryhighlightbackground)] == 1} then \
     {option add *Entry.highlightBackground  $env(tkentryhighlightbackground)}
  if {[info exists env(tkentryinsertbackground)] == 1} then \
     {option add *Entry.insertBackground  $env(tkentryinsertbackground)}
  if {[info exists env(tkentryhighlightcolor)] == 1} then \
     {option add *Entry.highlightColor  $env(tkentryhighlightbackcolor)}

#   text widget
  if {[info exists env(tktextbackground)] == 1} then \
     {option add *Text.background  $env(tktextbackground)}
  if {[info exists env(tktextforeground)] == 1} then \
     {option add *Text.foreground  $env(tktextforeground)}
  if {[info exists env(tktextselectbackground)] == 1} then \
     {option add *Text.selectBackground  $env(tktextselectbackground)}
  if {[info exists env(tktextselectforeground)] == 1} then \
     {option add *Text.selectForeground  $env(tktextselectforeground)}
  if {[info exists env(tktextinsertbackground)] == 1} then \
     {option add *Text.insertBackground  $env(tktextinsertbackground)}
  if {[info exists env(tktexthighlightbackground)] == 1} then \
     {option add *Text.highlightBackground  $env(tktexthighlightbackground)}
  if {[info exists env(tktexthighlightcolor)] == 1} then \
     {option add *Text.highlightColor  $env(tktexthighlightcolor)}


#   scale widget
  if {[info exists env(tkscaleactivebackground)] == 1} then \
     {option add *Scale.activeBackground  $env(tkscaleactivebackground)}
  if {[info exists env(tkscalebackground)] == 1} then \
     {option add *Scale.background  $env(tkscalebackground)}
  if {[info exists env(tkscaleforeground)] == 1} then \
     {option add *Scale.foreground  $env(tkscaleforeground)}
  if {[info exists env(tkscalehighlightbackground)] == 1} then \
     {option add *Scale.highlightBackground  $env(tkscalehighlightbackground)}
  if {[info exists env(tkscalehighlightcolor)] == 1} then \
     {option add *Scale.highlightColor  $env(tkscalehighlightcolor)}
  if {[info exists env(tkscaletroughcolor)] == 1} then \
     {option add *Scale.troughColor  $env(tkscaletroughcolor)}

#   menubutton widget
  if {[info exists env(tkmenubuttonactivebackground)] == 1} then \
     {option add *Menubutton.activeBackground  $env(tkmenubuttonactivebackground)}
  if {[info exists env(tkmenubuttonactiveforeground)] == 1} then \
     {option add *Menubutton.activeForeground  $env(tkmenubuttonactiveforeground)}
  if {[info exists env(tkmenubuttonbackground)] == 1} then \
     {option add *Menubutton.background  $env(tkmenubuttonbackground)}
  if {[info exists env(tkmenubuttonforeground)] == 1} then \
     {option add *Menubutton.foreground  $env(tkmenubuttonforeground)}
  if {[info exists env(tkmenubuttondisabledforeground)] == 1} then \
     {option add *Menubutton.disabledForeground  $env(tkmenubuttondisabledforeground)}

#   menu widget
  if {[info exists env(tkmenuactivebackground)] == 1} then \
     {option add *Menu.activeBackground  $env(tkmenuactivebackground)}
  if {[info exists env(tkmenuactiveforeground)] == 1} then \
     {option add *Menu.activeForeground  $env(tkmenuactiveforeground)}
  if {[info exists env(tkmenubackground)] == 1} then \
     {option add *Menu.background  $env(tkmenubackground)}
  if {[info exists env(tkmenuforeground)] == 1} then \
     {option add *Menu.foreground  $env(tkmenuforeground)}
  if {[info exists env(tkmenudisabledforeground)] == 1} then \
     {option add *Menu.disabledForeground  $env(tkmenudisabledforeground)}

#   message widget
  if {[info exists env(tkmessageforeground)] == 1} then \
     {option add *Message.foreground  $env(tkmessageforeground)}
  if {[info exists env(tkmessagebackground)] == 1} then \
     {option add *Message.background  $env(tkmessagebackground)}
  if {[info exists env(tkmessagehighlightbackground)] == 1} then \
     {option add *Message.highlightBackground  $env(tkmessagehighlightbackground)}
  if {[info exists env(tkmessagehighlightcolor)] == 1} then \
     {option add *Message.highlightColor  $env(tkmessagehighlightbackcolor)}

#   label widget
  if {[info exists env(tklabelforeground)] == 1} then \
     {option add *Label.foreground  $env(tklabelforeground)}
  if {[info exists env(tklabelbackground)] == 1} then \
     {option add *Label.background  $env(tklabelbackground)}
  if {[info exists env(tklabelhighlightbackground)] == 1} then \
     {option add *Label.highlightBackground  $env(tklabelhighlightbackground)}
  if {[info exists env(tklabelhighlightbackcolor)] == 1} then \
     {option add *Label.highlightColor  $env(tklabelhighlightcolor)}

#   listbox widget
  if {[info exists env(tklistboxbackground)] == 1} then \
     {option add *Listbox.background  $env(tklistboxbackground)}
  if {[info exists env(tklistboxforeground)] == 1} then \
     {option add *Listbox.foreground  $env(tklistboxforeground)}
  if {[info exists env(tklistboxhighlightbackground)] == 1} then \
     {option add *Listbox.highlightBackground  $env(tklistboxhighlightbackground)}
  if {[info exists env(tklistboxselectbackground)] == 1} then \
     {option add *Listbox.selectBackground  $env(tklistboxselectbackground)}
  if {[info exists env(tklistboxselectforeground)] == 1} then \
     {option add *Listbox.selectForeground  $env(tklistboxselectforeground)}
  if {[info exists env(tklistboxhighlightcolor)] == 1} then \
     {option add *Listbox.highlightColor  $env(tklistboxhighlightcolor)}

#   scrollbar widget
  if {[info exists env(tkscrollbaractivebackground)] == 1} then \
     {option add *Scrollbar.activeBackground  $env(tkscrollbaractivebackground)}
  if {[info exists env(tkscrollbarbackground)] == 1} then \
     {option add *Scrollbar.background  $env(tkscrollbarbackground)}
  if {[info exists env(tkscrollbarhighlightbackground)] == 1} then \
     {option add *Scrollbar.highlightBackground  $env(tkscrollbarhighlightbackground)}
  if {[info exists env(tkscrollbarhighlightcolor)] == 1} then \
     {option add *Scrollbar.highlightColor  $env(tkscrollbarhighlightcolor)}
  if {[info exists env(tkscrollbartroughcolor)] == 1} then \
     {option add *Scrollbar.troughColor  $env(tkscrollbartroughcolor)}

#    frame widget
  if {[info exists env(tkframebackground)] == 1} then \
     {option add *Frame.background  $env(tkframebackground)}
  if {[info exists env(tkframehighlightbackground)] == 1} then \
     {option add *Frame.highlightBackground  $env(tkframehighlightbackground)}
  if {[info exists env(tkframehighlightcolor)] == 1} then \
     {option add *Frame.highlightColor  $env(tkframehighlightcolor)}

#    spectrum widget
  if {[info exists env(tkspectrumbackground)] == 1} then \
     {option add *Spectrum.background  $env(tkspectrumbackground)}
  if {[info exists env(tkspectrumforeground)] == 1} then \
     {option add *Spectrum.foreground  $env(tkspectrumforeground)}
  if {[info exists env(tkspectrumtagcolour)] == 1} then \
     {option add *Spectrum.tagColour   $env(tkspectrumtagcolour)}
  if {[info exists env(tkspectrumboxcolour)] == 1} then \
     {option add *Spectrum.boxColour   $env(tkspectrumboxcolour)}
  if {[info exists env(tkspectrumactiveboxcolour)] == 1} then \
     {option add *Spectrum.activeboxColour   $env(tkspectrumactiveboxcolour)}
  if {[info exists env(tkspectrumtextcolour)] == 1} then \
     {option add *Spectrum.textColour  $env(tkspectrumtextcolour)}
  if {[info exists env(tkspectrumactivetextcolour)] == 1} then \
     {option add *Spectrum.activetextColour  $env(tkspectrumactivetextcolour)}
  if {[info exists env(tkspectrumgatecolour)] == 1} then \
     {option add *Spectrum.gateColour  $env(tkspectrumgatecolour)}
  if {[info exists env(tkspectrumpolycolour)] == 1} then \
     {option add *Spectrum.polyColour  $env(tkspectrumpolycolour)}
  if {[info exists env(tkspectrumpointercolour)] == 1} then \
     {option add *Spectrum.pointerColour  $env(tkspectrumpointercolour)}
  if {[info exists env(tkspectrumspeccolour)] == 1} then \
     {option add *Spectrum.specColour  $env(tkspectrumspeccolour)}

}

if {[info exists env(tkfixedfont)]} then {set fixed $env(tkfixedfont)} else {set fixed "courier"}

proc font-config {fmly pixslz} {
  global env fixed

  if {$pixslz == "small"}  then {set pixslz 8}
  if {$pixslz == "medium"} then {set pixslz 12}
  if {$pixslz == "large"}  then {set pixslz 17}

  set fndry *

     set footersize [expr $pixslz - 2]
     set dialogsize [expr $pixslz * 3 / 2]

  puts stdout "Using font foundry $fndry family $fmly and font size $pixslz"
  puts stdout "Using fixed width font family $fixed"

  set env(tkfontdialogn) "-$fndry-$fmly-bold-r-normal-*-$dialogsize-120-*-*-*-*-iso8859-*"

  set env(tkfontfootern) "-$fndry-$fmly-medium-r-normal-*-$footersize-120-*-*-*-*-iso8859-*"
  set env(tkfontfooterb) "-$fndry-$fmly-bold-r-normal-*-$footersize-120-*-*-*-*-iso8859-*"

  set env(tkfontbuttonn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontbuttonb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontlabeln) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontlabelb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontFlistboxn) "-$fndry-$fixed-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontFlistboxb) "-$fndry-$fixed-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontVlistboxn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontVlistboxb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontVtextn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontVtextb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontFtextn) "-$fndry-$fixed-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontFtextb) "-$fndry-$fixed-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontmessagen) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontmessageb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontentryn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontentryb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontmenubuttonn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontmenubuttonb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontmenun) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontmenub) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontradiobuttonn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontradiobuttonb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontcheckbuttonn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontcheckbuttonb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontscalen) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontscaleb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

  set env(tkfontspectrumn) "-$fndry-$fmly-medium-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"
  set env(tkfontspectrumb) "-$fndry-$fmly-bold-r-normal-*-$pixslz-120-*-*-*-*-iso8859-*"

}

proc font-config_8x {fmly size} {
  global env fixed

     switch $size {
         small  {
           set size 10
           set footersize 8
           set dialogsize 12
           set listboxsize 10
           set textsize    10
         }
         medium  {
           set size 12
           set footersize 10
           set dialogsize 14
           set listboxsize 12
           set textsize    12
         }
         large  {
           set size 14
           set footersize 12
           set dialogsize 16
           set listboxsize 14
           set textsize    14
         }
         default {
           set footersize  [expr $size * 8 / 10]
           set dialogsize  [expr $size * 14 / 10]
           set listboxsize $size
           set textsize    $size
         }
     }

  set scaling [tk scaling]
  if {[info exists env(TKSCALING)]} then {tk scaling $env(TKSCALING)} else {tk scaling 1.0}

  puts stdout "Using font family $fmly and font size $size;  footer size $footersize and dialog size $dialogsize"
  puts stdout "Using fixed width font family $fixed"
  puts stdout "Original Tk scaling factor $scaling - now set to [tk scaling]"

set env(tkfontdialogn) "$fmly $dialogsize bold roman"

set env(tkfontfootern) "$fmly $footersize normal roman"
set env(tkfontfooterb) "$fmly $footersize bold roman"

set env(tkfontFlistboxn) "$fixed $listboxsize normal roman"
set env(tkfontFlistboxb) "$fixed $listboxsize bold roman"

set env(tkfontVlistboxn) "$fmly $listboxsize normal roman"
set env(tkfontVlistboxb) "$fmly $listboxsize bold roman"

set env(tkfontlistboxn) "$fixed $listboxsize normal roman"
set env(tkfontlistboxb) "$fixed $listboxsize bold roman"

set env(tkfontspectrumn) "$fmly $size normal roman"
set env(tkfontspectrumb) "$fmly $size bold roman"

set env(tkfontlabeln) "$fmly $size normal roman"
set env(tkfontlabelb) "$fmly $size bold roman"

set env(tkfontbuttonn)  "$fmly $size normal roman"
set env(tkfontbuttonb)  "$fmly $size bold roman"

set env(tkfontcheckbuttonn) "$fmly $size normal roman"
set env(tkfontcheckbuttonb) "$fmly $size bold roman"

set env(tkfontentryn) "$fmly $size normal roman"
set env(tkfontentryb) "$fmly $size bold roman"

set env(tkfontmenubuttonn) "$fmly $size normal roman"
set env(tkfontmenubuttonb) "$fmly $size bold roman"

set env(tkfontradiobuttonn) "$fmly $size normal roman"
set env(tkfontradiobuttonb) "$fmly $size bold roman"

set env(tkfontmenun) "$fmly $size normal roman"
set env(tkfontmenub) "$fmly $size bold roman"

set env(tkfontmessagen) "$fmly $size normal roman"
set env(tkfontmessageb) "$fmly $size bold roman"

set env(tkfontVtextn) "$fmly $textsize normal roman"
set env(tkfontVtextb) "$fmly $textsize bold roman"

set env(tkfonttextn) "$fmly $textsize normal roman"
set env(tkfonttextb) "$fmly $textsize bold roman"

set env(tkfontFtextn) "$fixed $textsize normal roman"
set env(tkfontFtextb) "$fixed $textsize bold roman"

set env(tkfontscalen) "$fmly $size normal roman"
set env(tkfontscaleb) "$fmly $size bold roman"

set env(tkfontspectrumn) "$fixed $size normal roman"
set env(tkfontspectrumb) "$fixed $size bold roman"

}


proc font-setup {} {
  global env
  if {[info exists env(tkfontbuttonn)] == 1}      then {option add *Button.font  $env(tkfontbuttonn)}
  if {[info exists env(tkfontlabeln)] == 1}       then {option add *Label.font   $env(tkfontlabeln)}
  if {[info exists env(tkfontlistboxn)] == 1}     then {option add *Listbox.font $env(tkfontlistboxn)}
  if {[info exists env(tkfonttextn)] == 1}        then {option add *Text.font    $env(tkfonttextn)}
  if {[info exists env(tkfontmessagen)] == 1}     then {option add *Message.font $env(tkfontmessagen)}
  if {[info exists env(tkfontentryn)] == 1}       then {option add *Entry.font   $env(tkfontentryn)}
  if {[info exists env(tkfontmenubuttonn)] == 1}  then {option add *Menubutton.font  $env(tkfontmenubuttonn)}
  if {[info exists env(tkfontmenun)] == 1}        then {option add *Menu.font    $env(tkfontmenun)}
  if {[info exists env(tkfontradiobuttonn)] == 1} then {option add *Radiobutton.font $env(tkfontradiobuttonn)}
  if {[info exists env(tkfontcheckbuttonn)] == 1} then {option add *Checkbutton.font $env(tkfontcheckbuttonn)}
  if {[info exists env(tkfontscalen)] == 1}       then {option add *Scale.font   $env(tkfontscalen)}
  if {[info exists env(tkfontspectrumn)] == 1}    then {option add *Spectrum.font   $env(tkfontspectrumn)}
}

proc font-setup {} {}


# change default tk bindings to delete backwards ...

bind Entry <Delete> {
    if [%W selection present] {
        %W delete sel.first sel.last
    } else {
        %W delete [expr [%W index insert] -1 ]
    }
}

bind Text <Delete> {
    if {[%W tag nextrange sel 1.0 end] != ""} {
        %W delete sel.first sel.last
    } else {
        %W delete insert-1c
        %W see insert
    }
}

proc tkListboxBeginSelect {w el} {
    global tkPriv
    if {[$w cget -selectmode]  == "multiple"} {
        if [$w selection includes $el] {
            $w selection clear $el
        } else {
            $w selection set $el
        $w selection anchor $el
        set tkPriv(listboxSelection) {}
        set tkPriv(listboxPrev) $el
        }
    } else {
        $w selection clear 0 end
        $w selection set $el
        $w selection anchor $el
        set tkPriv(listboxSelection) {}
        set tkPriv(listboxPrev) $el
    }
}

proc tkListboxMotion {w el} {
    global tkPriv
    if {$el == $tkPriv(listboxPrev)} {
        return
    }
    set anchor [$w index anchor]
    switch [$w cget -selectmode] {
        browse {
            $w selection clear 0 end
            $w selection set $el
            set tkPriv(listboxPrev) $el
        }
        extended {
            set i $tkPriv(listboxPrev)
            if [$w selection includes anchor] {
                $w selection clear $i $el
                $w selection set anchor $el
            } else {
                $w selection clear $i $el
                $w selection clear anchor $el
            }
            while {($i < $el) && ($i < $anchor)} {
                if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {
                    $w selection set $i
                }
                incr i
            }
            while {($i > $el) && ($i > $anchor)} {
                if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {
                    $w selection set $i
                }
                incr i -1
            }
            set tkPriv(listboxPrev) $el
        }
        multiple {
            set i $tkPriv(listboxPrev)
            if [$w selection includes anchor] {
                $w selection clear $i $el
                $w selection set anchor $el
            } else {
                $w selection clear $i $el
                $w selection clear anchor $el
            }
            while {($i < $el) && ($i < $anchor)} {
                if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {
                    $w selection set $i
                }
                incr i
            }
            while {($i > $el) && ($i > $anchor)} {
                if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {
                    $w selection set $i
                }
                incr i -1
            }
            set tkPriv(listboxPrev) $el
        }
    }
}
