#  V551.defn.tcl

proc {Add_CAEN V551_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME Intr_Level          "-a$A32addrbase -w32 -o0x02 -pwo -d16 -l3 -b0 -zd -i$interruptlevel"
   define-vme-register $name xVME Intr_Vec            "-a$A32addrbase -w32 -o0x00 -pwo -d16 -l8 -b0 -zd -i$interruptvector"

   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0x04 -prw -d16"
   define-vme-register $name xVME Trigger             "-a$A32addrbase -w32 -o0x06 -prw -d16"

   define-vme-register $name xVME Status              "-a$A32addrbase -w32 -o0x08 -prw -d16 -l6 -b0 -zx"
   define-vme-register $name xVME Status.IntDelay     "-a$A32addrbase -w32 -o0x08 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME Status.Veto         "-a$A32addrbase -w32 -o0x08 -prw -d16 -l1 -b1 -zd"
   define-vme-register $name xVME Status.AutoTrig     "-a$A32addrbase -w32 -o0x08 -prw -d16 -l1 -b2 -zd"
   define-vme-register $name xVME Status.DataRdy      "-a$A32addrbase -w32 -o0x08 -pro -d16 -l1 -b3 -zd"
   define-vme-register $name xVME Status.Busy         "-a$A32addrbase -w32 -o0x08 -pro -d16 -l1 -b4 -zd"
   define-vme-register $name xVME Status.ActSeq       "-a$A32addrbase -w32 -o0x08 -pro -d16 -l1 -b5 -zd"
   
   define-vme-register $name xVME Test              "-a$A32addrbase -w32 -o0x0a -prw -d16 -l4 -b0 -zx"
   define-vme-register $name xVME Test.TM           "-a$A32addrbase -w32 -o0x0a -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME Test.CL           "-a$A32addrbase -w32 -o0x0a -prw -d16 -l1 -b1 -zd"
   define-vme-register $name xVME Test.SL           "-a$A32addrbase -w32 -o0x0a -prw -d16 -l1 -b2 -zd"
   define-vme-register $name xVME Test.PL           "-a$A32addrbase -w32 -o0x0a -pro -d16 -l1 -b3 -zd"

   define-vme-register $name xVME NumChan           "-a$A32addrbase -w32 -o0x0c -prw -d16 -l11 -b0 -zd"
   
   define-vme-register $name xVME T1                "-a$A32addrbase -w32 -o0x0e -prw -d16 -l8 -b0 -zd"
   define-vme-register $name xVME T2                "-a$A32addrbase -w32 -o0x10 -prw -d16 -l8 -b0 -zd"
   define-vme-register $name xVME T3                "-a$A32addrbase -w32 -o0x12 -prw -d16 -l8 -b0 -zd"
   define-vme-register $name xVME T4                "-a$A32addrbase -w32 -o0x14 -prw -d16 -l8 -b0 -zd"
   define-vme-register $name xVME T5                "-a$A32addrbase -w32 -o0x16 -prw -d16 -l8 -b0 -zd"
   
   define-vme-register $name xVME IntDac            "-a$A32addrbase -w32 -o0x18 -pwo -d16 -l0 -b0 -zd"
   
   define-vme-register $name xVME ModID#1           "-a$A32addrbase -w32 -o0xfe -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#2           "-a$A32addrbase -w32 -o0xfc -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#3           "-a$A32addrbase -w32 -o0xfa -pro -d16 -l0 -b0 -zx"
}

proc {CAEN V551_registers} {} {
    global registers_table

    set registers_table   {                                              \
        {"Interrupt Level Register"            Intr_Level}               \
        {"Interrupt Vector Register"           Intr_Vec}                 \
        {"Status Register"                     Status}                   \
        {"Test Register"                       Test}                     \
        {"Number of Channels Register"         NumChan}                  \
        {"T1 Register"                         T1}                       \
        {"T2 Register"                         T2}                       \
        {"T3 Register"                         T3}                       \
        {"T4 Register"                         T4}                       \
        {"T5 Register"                         T5}                       \
        {"Module ID Word 1"                    ModID#1}                  \
        {"Module ID Word 2"                    ModID#2}                  \
        {"Module ID Word 3"                    ModID#3}                  \
    }
}


proc {CAEN V551_DAQ-reset} {args} {
#   V551
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModID#1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {CAEN V551_DAQ-flush} {args} {
#   V551
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
}

proc {CAEN V551_DAQ-go} {args} {
#   V551
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
}

proc {CAEN V551_DAQ-halt} {args} {
#   V551
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
}

proc {CAEN V551_DAQ-setup} {args} {
#   V551
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

}

#   for parameter save/restore
set {CAEN V551_registersavepatterns} {}

