#    VME register access procedures

    variable Rmsg ""
    variable Wmsg ""

   proc ReadRegister {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegister $r.$RegName returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister $r.$RegName returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
# puts "WriteRegister $r.$RegName $RegData [format 0x%x $RegData]"
#           InsertLog "WriteRegister $r.$RegName $RegData [format 0x%x $RegData] returned: [lindex $Wmsg 5]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc WriteBitRegister {RegName Bit RegData} {

        set Mask [expr 1 << $Bit]

        if {$RegData == 0} {WriteRegister $RegName [expr [ReadRegister $RegName] & ~$Mask]}
        if {$RegData == 1} {WriteRegister $RegName [expr [ReadRegister $RegName] | $Mask]}
   }

   proc ReadBitRegister {RegName Bit} {

       return [expr ([ReadRegister $RegName] >> $Bit) & 1]
   }


  proc DBSetValue {name value} {
       upvar #0 VMEAccessServer_DBRootName RootName
       upvar #0 VMEAccessServer_DBNodeBase NodeBase
       variable ModuleName
       variable ModuleIndex
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set Path [set RootName]/[set NodeBase]/[set ModuleName]#[set ModuleIndex]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $name $value int} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$name == "NULL"} then {
                    InsertLog "$Path created"
                } else {
                    if {$LogFlag == 1} {InsertLog "$Path: $name set to $value"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT set: error [second $m]; [third $m]"
            }
        }
  }

  proc DBGetValue {name} {
       upvar #0 VMEAccessServer_DBRootName RootName
       upvar #0 VMEAccessServer_DBNodeBase NodeBase
       variable ModuleName
       variable ModuleIndex
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set Path [set RootName]/[set NodeBase]/[set ModuleName]#[set ModuleIndex]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $name} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
            set value "Error!"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
                set value "Error!"
            }
        }
        return $value
  }





