# C1011.tcl---C1011 module control frame



set frame "C1011"
set frametitle "C1011 VME Clock/Timestamp Setup & Monitor"
set icontitle "C1011"

set modulename  c1011
set moduletype  "C1011"

loadsource common.vme

set allmodules 0


set w2r(VSN)        "vsn"
set w2r(DELAY)      "delay"
set w2r(STATUS)      "status"
set w2r(CONTROL)    "control"
set w2r(MODE)       "mode"


proc click-widget {w v} {
    global w2r
    global modulename module
    global allmodules

    set register $w2r($w)

    if {$allmodules == 0} then {
        write-vme-register $modulename#$module.$register $v
    } else {
        write-vme-registers $modulename#\[?,??\].$register $v
    }

    click-redisplay
}

proc click-select-module {v} {
   global debug module maxmodule
   if {$debug} then {puts stderr "click-select-module with argument \{$v\}"}
   set module $v
   if {$module<1} then {set module 1}
   if {$module>$maxmodule} then {set module $maxmodule}
   click-redisplay
}

proc click-select-adc {v} {}

proc click-all-modules {v} {global allmodules; set allmodules $v}

proc repaint {} {}

proc click-redisplay {} {
   global w2r modulename module maxmodule

   set maxmodule [inform vmecontrol inquire [set modulename]count]
   set menu {}
   for {set i 1} {$i <= $maxmodule} {incr i} {lappend menu $i}
   :modify MODULE-SEL :strings $menu
   :modify MODULE-NUM :max $maxmodule
   :modify MODULE-NUM :value $module

   foreach w {MODE STATUS VSN DELAY} {
       set register $w2r($w)
       :modify $w :value [read-vme-register $modulename#$module.$register]
   }    
}

proc click-software {} {
   global modulename
   inform [set modulename]sftwre start
}

proc click arg {
   global debug actionlist
   if {$debug} then {insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]

   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL      -
      MODULE-NUM  {click-select-module $v}

      ALL-MODULES {click-all-modules $v}

      VSN  -
      CONTROL -
      DELAY       {click-widget $w $v}

      ENGINEERING       {click-$v}
      REDISPLAY  	{click-redisplay}

      default           {
           set p "click_[lowercase $w]"
           if {[info procs $p] == "$p"} then {$p} else {insert-debug "$arg"}
      }
   }
}


proc make-frame {} {
  global env actionlist
  global module maxmodule modulelist maxadc

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE  :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 20

     :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 :value $module
     :menubutton MODULE-SEL :label "select:" :strings $modulelist
     :hskip 50
     :checkbox ALL-MODULES :label "Act on ALL modules?"
     :next-row T
     :number VSN       :label "VSN"   :w 3  :min 0 :max 255
     :slider DELAY     :label "Reset Counter Delay (200ns)"  :min 0 :max 255
     :next-row T
     :text MODE      :label "Mode Register" :w 6 :deaf T
     :text STATUS    :label "Status Register" :w 6 :deaf T
     :text CONTROL   :label "Control Register" :w 6
    
   :panel CLICK :layout B :padx 10 :after FOOTER
     :layout H; :col-gap 30; :row-gap 10
      :vskip 10
      :button REDISPLAY

      :menubutton ENGINEERING :label "Engineering"  :menu [list software]
 
  :show T

}
