# Read the input FIFO data and format it as a line of text

# assumes the A32 pointer is set to the base address
global EGreport
# log flag set to 0 stops the writing VME access reports to the log window
# EGreport set to -1 probably stops any errors causing popups ??
set LogFlag 0
set EGreport -1
# input FIFO details
set time_ls	0x500
set time_ms	0x504
set ip_count	0x508
set grpA	0x510
set grpB	0x520
set ip_type	0x530

#Middle FIFO details
set fdata	0x0010
set track	0x0014
set fflags	0x0018 

set fileId 0
set file_ok 0
# type table 
set ip_typetable(0)	GroupA
set ip_typetable(1)	GroupB
set ip_typetable(2)	SYNC
set ip_typetable(3)	Pause
set ip_typetable(4)	Resume
set ip_typetable(5)	GroupA_Gated
set ip_typetable(6)	GroupB_Gated

#variables for keeping track of time ;-)
set tip_old_m 0
set tip_old_l 0 
set tip_tim_ok 0 
set ip_idx 0

proc file_setup {} {
global fileId file_ok
	if [catch { open /MIDAS/vme/tcl/diag-scripts/pr_fifo.txt {RDWR CREAT} } fileId ] {
		log "Cannot open file pr_fifo.txt: $fileId"
		set file_ok 0
	} else {
		set file_ok 1
	}
}
	
proc time48_check {tim_bot tim_top } {
global tip_old_l tip_old_m tip_tim_ok ip_idx
	if { $tim_bot > $tip_old_l  && $tim_top == $tip_old_m  || $tim_top >= $tip_old_m} {
		set tip_old_l $tim_bot
		set tip_old_m $tim_top
		set tip_tim_ok 1
	} else {
		log "Index: [format "%d" $ip_idx ] => time error"
		set tip_tim_ok 0 
	}	
}
	
# read input fifo and format for one line
proc inp_read {} {
global time_ms time_ls grpA grpB ip_type ip_count fileId file_ok ip_idx
	set time_top [scan [ rdl $time_ms ] {%x} ]
	set time_bot [scan [rdl $time_ls ]  {%x} ]
	set A_patt [scan [ rdl $grpA] {%x} ]
	set B_patt [scan [ rdl $grpB] {%x} ]
	set typ_val [scan [rdl $ip_type] {%x} ]
	time48_check $time_bot $time_top
	if { $file_ok == 1 } {
		puts $fileId "Input: T:[format "%04X%07X" $time_top $time_bot ], A:[format "%04X" $A_patt], B: [format "%04X" $B_patt], Type:[format "%02X" $typ_val]"
	} else {
	log "Input: T:[format "%04X%07X" $time_top $time_bot ], A:[format "%04X" $A_patt], B: [format "%04X" $B_patt], Type:[format "%02X" $typ_val]"
	}
}
# read main fifo and output it with the track
proc main_read {} {
global fdata track fflags file_ok
	set mf_id [scan [ rdl $fdata] {%x} ] 
	set mf_track [scan [ rdl $track ] {%x} ]
	set mf_time [scan [ rdl $fdata] {%x} ]
	if { $file_ok == 0 } {
		log "Main: Track [format "%04X" $mf_track ]: Data [format "%08X : %08X" $mf_id $mf_time ]"
	}
}
proc dump_it {} {
global ip_count ip_idx tip_old_m tip_old_l
	set words [scan [rdl $ip_count] {%x}]

	log " $words words in the input fifo "
	for { set i 0 } { $i < $words } { incr i } {
		inp_read
		set ip_idx $i
		main_read
		if { $i == 1 } { log "Started at [format "%04X%07X" $tip_old_m $tip_old_l ]" }

		update idletasks
	}
	log "ended at [format "%04X%07X" $tip_old_m $tip_old_l ]"
}
file_setup
dump_it
close $fileId

