#  V1724.defn.tcl

global DPPEnable
set DPPEnable 1

proc {Add_CAEN V1724_Module} {name server addressdata} {
   global CurrentVMEServer
   global DPPEnable

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME ConfigReload        "-a$A32addrbase -w32 -o0xef34 -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0xef28 -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Reset               "-a$A32addrbase -w32 -o0xef24 -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Scratch             "-a$A32addrbase -w32 -o0xef20 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME BLTEventNum         "-a$A32addrbase -w32 -o0xef1c -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME VMEBaseAddress      "-a$A32addrbase -w32 -o0xef10 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME MCSTBaseAddress     "-a$A32addrbase -w32 -o0xef0c -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Status              "-a$A32addrbase -w32 -o0xef04 -pro -d32 -l3 -b0 -zx"
   define-vme-register $name xVME Control             "-a$A32addrbase -w32 -o0xef00 -prw -d32 -l0 -b0 -zd"

   define-vme-register $name xVME AnalogMon           "-a$A32addrbase -w32 -o0x8150 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME EventSize           "-a$A32addrbase -w32 -o0x814c -pro -d32 -l0 -b0 -zd"
   define-vme-register $name xVME MonitorMode         "-a$A32addrbase -w32 -o0x8144 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME BoardInfo           "-a$A32addrbase -w32 -o0x8140 -pro -d32 -l0 -b0 -zx"
   define-vme-register $name xVME MonitorDAC          "-a$A32addrbase -w32 -o0x8138 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME EventsStored        "-a$A32addrbase -w32 -o0x812c -pro -d32 -l0 -b0 -zd"
   define-vme-register $name xVME DownSample          "-a$A32addrbase -w32 -o0x8128 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME FPGARev             "-a$A32addrbase -w32 -o0x8124 -pro -d32 -l0 -b0 -zx"
   define-vme-register $name xVME ChEnable            "-a$A32addrbase -w32 -o0x8120 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME FPIOControl         "-a$A32addrbase -w32 -o0x811c -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME FPIOData            "-a$A32addrbase -w32 -o0x8118 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME PostTrig            "-a$A32addrbase -w32 -o0x8114 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME FPTrigOutEnable     "-a$A32addrbase -w32 -o0x8110 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME TrigSrcEnable       "-a$A32addrbase -w32 -o0x810c -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME SoftTrig            "-a$A32addrbase -w32 -o0x8108 -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME AcqStatus           "-a$A32addrbase -w32 -o0x8104 -pro -d32 -l0 -b0 -zx"
   define-vme-register $name xVME AcqControl          "-a$A32addrbase -w32 -o0x8100 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME CustomSize          "-a$A32addrbase -w32 -o0x8020 -prw -d32 -l0 -b0 -zd"
if {$DPPEnable != 0} {
   define-vme-register $name xVME PostTrigSize        "-a$A32addrbase -w32 -o0x8014 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME SoftwareSyncReset   "-a$A32addrbase -w32 -o0x813c -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME FPDAPulser          "-a$A32addrbase -w32 -o0x8154 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME FirmWareLicense     "-a$A32addrbase -w32 -o0x8158 -pro -d32 -l0 -b0 -zx"
}
   define-vme-register $name xVME BufferFree          "-a$A32addrbase -w32 -o0x8010 -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME BufferOrg           "-a$A32addrbase -w32 -o0x800c -prw -d32 -l0 -b0 -zd"
   define-vme-register $name xVME ChConfigClr         "-a$A32addrbase -w32 -o0x8008 -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME ChConfigSet         "-a$A32addrbase -w32 -o0x8004 -pwo -d32 -l0 -b0 -zx"
   define-vme-register $name xVME ChConfig            "-a$A32addrbase -w32 -o0x8000 -prw -d32 -l0 -b0 -zx"

if {$DPPEnable != 0} {
      define-vme-register $name xVME ChDPP_PAR1  "-a$A32addrbase -w32 -o0x8024 -pwo -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDPP_PAR2  "-a$A32addrbase -w32 -o0x8028 -pwo -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDPP_PAR3  "-a$A32addrbase -w32 -o0x802c -pwo -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDPP_PAR4  "-a$A32addrbase -w32 -o0x8030 -pwo -d32 -l0 -b0 -zx"
} else {
      define-vme-register $name xVME ChZS_NSAMP  "-a$A32addrbase -w32 -o0x8028 -pwo -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChZS_THRES  "-a$A32addrbase -w32 -o0x8024 -pwo -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChOUThresh  "-a$A32addrbase -w32 -o0x8084 -pwo -d32 -l0 -b0 -zd"
      define-vme-register $name xVME ChThresh    "-a$A32addrbase -w32 -o0x8080 -pwo -d32 -l0 -b0 -zd"
}

      define-vme-register $name xVME ChADCConfig "-a$A32addrbase -w32 -o0x809c -pwo -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDAC       "-a$A32addrbase -w32 -o0x8098 -pwo -d32 -l0 -b0 -zx"
 
   for {set i 0} {$i < 8} {incr i} {
      define-vme-register $name xVME ChADCConfig$i "-a$A32addrbase -w32 -o[expr 0x109c+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDAC$i       "-a$A32addrbase -w32 -o[expr 0x1098+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChBufs$i      "-a$A32addrbase -w32 -o[expr 0x1094+($i*0x100)] -prw -d32 -l0 -b0 -zd"
      define-vme-register $name xVME ChFPGARev$i   "-a$A32addrbase -w32 -o[expr 0x108c+($i*0x100)] -pro -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChStatus$i    "-a$A32addrbase -w32 -o[expr 0x1088+($i*0x100)] -pro -d32 -l0 -b0 -zx"
if {$DPPEnable != 0} {
      define-vme-register $name xVME ChDPP_PAR1$i  "-a$A32addrbase -w32 -o[expr 0x1024+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDPP_PAR2$i  "-a$A32addrbase -w32 -o[expr 0x1028+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDPP_PAR3$i  "-a$A32addrbase -w32 -o[expr 0x102c+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChDPP_PAR4$i  "-a$A32addrbase -w32 -o[expr 0x1030+($i*0x100)] -prw -d32 -l0 -b0 -zx"
} else {
      define-vme-register $name xVME ChZS_NSAMP$i  "-a$A32addrbase -w32 -o[expr 0x1028+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChZS_THRES$i  "-a$A32addrbase -w32 -o[expr 0x1024+($i*0x100)] -prw -d32 -l0 -b0 -zx"
      define-vme-register $name xVME ChOUThresh$i "-a$A32addrbase -w32 -o[expr 0x1084+($i*0x100)] -prw -d32 -l0 -b0 -zd"
      define-vme-register $name xVME ChThresh$i   "-a$A32addrbase -w32 -o[expr 0x1080+($i*0x100)] -prw -d32 -l0 -b0 -zd"
}
   }

   define-vme-register $name xVME DataItem            "-a$A32addrbase -w32 -o0x0 -pro -d32 -l0 -b0 -zx"
   define-vme-register $name bVME RdOutBuffer         "-a$A32addrbase -w32 -o0x0 -pro -d32 -zx -l64"
}

proc {CAEN V1724_registers} {} {
    global registers_table

    set registers_table   {                                              \
        {"Channel Configuration"      ChConfig}             \
        {"Channel Enable"      ChEnable}             \
        {"Acquisition Status"      AcqStatus}             \
        {"Acquisition Control"      AcqControl}             \
        {"Event Size"      EventSize}             \
        {"Events Stored"      EventsStored}             \
        {"Buffer Org"      BufferOrg}             \
    }
    for {set i 0} {$i < 8} {incr i} {
        lappend registers_table [list "Ch $i Status"  ChStatus$i]
    }
}

proc {CAEN V1724_DAQ-reset} {args} {
#   V1724
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {CAEN V1724_DAQ-flush} {args} {
#   V1724
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

     write-vme-register $module.Clear 0

}

proc {CAEN V1724_DAQ-go} {args} {
#   V1724
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

     write-vme-register $module.Control 16     ;# set BERR enable
     write-vme-register $module.BLTEventNum 1
     write-vme-register $module.Clear 0
     write-vme-register $module.SoftwareSyncReset 0  
     write-vme-register $module.AcqControl 4   ;# set Acquisition Run
}

proc {CAEN V1724_DAQ-halt} {args} {
#   V1724
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#     write-vme-register $module.AcqControl 0   ;# unset Acquisition Run
}

proc {CAEN V1724_DAQ-setup} {args} {
#   V1724
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

}

#   for parameter save/restore
   set {CAEN V1724_registersavepatterns} {ChEnable ChConfig BufferOrg TrigSrcEnable FPTrigOutEnable PostTrig FPIOControl CustomSize AnalogMon}

   for {set i 0} {$i < 8} {incr i} {
      lappend {CAEN V1724_registersavepatterns} ChDAC$i  
if {$DPPEnable != 0} {
      lappend {CAEN V1724_registersavepatterns} ChDPP_PAR1$i 
      lappend {CAEN V1724_registersavepatterns} ChDPP_PAR2$i
      lappend {CAEN V1724_registersavepatterns} ChDPP_PAR3$i  
      lappend {CAEN V1724_registersavepatterns} ChDPP_PAR4$i  
} else {
      lappend {CAEN V1724_registersavepatterns} ChZS_NSAMP$i 
      lappend {CAEN V1724_registersavepatterns} ChZS_THRES$i
      lappend {CAEN V1724_registersavepatterns} ChOUThresh$i 
      lappend {CAEN V1724_registersavepatterns} ChThresh$i  
}
   }




